Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## de.grogra.imp3d.shading
Class SunSkyLight

    java.lang.Object
      de.grogra.graph.impl.Edge
          de.grogra.graph.impl.Node
              de.grogra.imp3d.shading.ChannelMapNode
                  de.grogra.imp3d.shading.ColorMapNode
                      de.grogra.imp3d.shading.Material
                          de.grogra.imp3d.shading.SunSkyLight

All Implemented Interfaces:
  Icon, IconSource, ChannelMap, ColorMap, Manageable, PersistenceCapable, Shareable, RenderedIcon, Emitter, Light, Scattering, Shader, UserFields, XObject, Map, java.io.Serializable

    public class SunSkyLight

extends Material
implements Light

See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class de.grogra.graph.impl.Node
`Node.AccessorBridge, Node.FieldAttributeAccessor, Node.NType`

Nested classes/interfaces inherited from interface de.grogra.util.Map
`Map.Chain`

Field Summary
`static Node.NType` | `$TYPE`
`static Node.NType.Field` | `disableLight$FIELD`
`static Node.NType.Field` | `disableSun$FIELD`
`static Node.NType.Field` | `radianceFactor$FIELD`
`static Node.NType.Field` | `sun$FIELD`
`static Node.NType.Field` | `turbidity$FIELD`

Fields inherited from class de.grogra.imp3d.shading.ChannelMapNode
`AMBIENT, COLOR, COLOR_2, DIFFUSE_TRANSPARENCY, DISPLACEMENT, EMISSIVE, FIRST_OP, INPUT, input$FIELD, MIN_UNUSED_SPECIAL_OF_TARGET, SECOND_OP, SHININESS, SPECULAR, TRANSPARENCY, TRANSPARENCY_SHININESS`

Fields inherited from class de.grogra.graph.impl.Node
`ADDITIONAL_FIELDS, bits, DELETED, EXTENT_BIT, EXTENT_MASK, extentIndex$FIELD, extentTail$FIELD, HAS_OBSERVERS, IS_INTERPRETIVE, isInterpretive$FIELD, LAST_EXTENT_INDEX, layer$FIELD, MARK, mark$FIELD, MIME_TYPE, MIN_UNUSED_SPECIAL_OF_SOURCE, name$FIELD, USED_BITS`

Fields inherited from interface de.grogra.ray.physics.Light
`AMBIENT, AREA, DIRECTIONAL, NO_LIGHT, POINT, SKY`

Fields inherited from interface de.grogra.ray.physics.Scattering
`DELTA_FACTOR, IS_NON_OPAQUE, MIN_UNUSED_FLAG, NEEDS_NORMAL, NEEDS_POINT, NEEDS_TANGENTS, NEEDS_TRANSFORMATION, NEEDS_UV, RANDOM_RAYS_GENERATE_ORIGINS`

Fields inherited from interface de.grogra.ray.physics.Shader
`LAMBERTIAN_VARIANCE`

Fields inherited from interface de.grogra.icon.Icon
`DEFAULT, DISABLED`

Fields inherited from interface de.grogra.util.Map
`DEFAULT_VALUE, EMPTY_MAP`

Constructor Summary
`SunSkyLight()`

Method Summary
`void` | `accept(ChannelMapNodeVisitor visitor)`
`void` | `accept(LightVisitor visitor)`
`void` | `accept(ShaderVisitor visitor)`
`double` | `completeRay(Environment env, Point3d vertex, Ray out)`
`float` | `computeBSDF(Environment env, Vector3f in, Spectrum specIn, Vector3f out, boolean adjoint, Spectrum bsdf)` Evaluates bidirectional scattering distribution function for given input.
`double` | `computeExitance(Environment env, Spectrum exitance)` Evaluates the exitance function for given input.
`void` | `computeMaxRays(Environment env, Vector3f in, Spectrum specIn, Ray reflected, Tuple3f refVariance, Ray transmitted, Tuple3f transVariance)` Computes, for the given input, the reflected and transmitted importance rays for which the reflection/transmission probability densities (integrated over the spectrum) attain a maximum.
`void` | `generateRandomOrigins(Environment env, RayList out, java.util.Random random)` Pseudorandomly generates, for the given input, a set of origins for this emitter.
`void` | `generateRandomRays(Environment env, Vector3f out, Spectrum specOut, RayList rays, boolean adjoint, java.util.Random random)` Pseudorandomly generates, for the given input, a set of scattered rays.
`int` | `getAverageColor()` Returns an average color for the scattering entity.
`int` | `getFlags()`
`int` | `getLightType()` Determines the type of light source which is represented by this light.
`protected Node.NType` | `getNTypeImpl()` This method returns the `Node.NType` which describes the managed fields of the class of this node.
`float` | `getRadianceFactor()`
`Vector3d` | `getSun()`
`double` | `getTotalPower(Environment env)` Computes the total power of this light source which is emitted to the region defined by `env.bounds`.
`float` | `getTurbidity()`
`boolean` | `isDisableLight()`
`boolean` | `isDisableSun()`
`boolean` | `isIgnoredWhenHit()` Determines whether the light source shall be ignored when a shot ray happens to hit the geometry of the light source.
`boolean` | `isShadowless()` Determines whether the light source casts shadows or not.
`boolean` | `isTransparent()`
`protected Node` | `newInstance()` This method returns a new instance of the class of this node.
`void` | `setDisableLight(boolean value)`
`void` | `setDisableSun(boolean value)`
`void` | `setRadianceFactor(float value)`
`void` | `setSun(Vector3d value)`
`void` | `setTurbidity(float value)`
`void` | `shade(Environment env, RayList in, Vector3f out, Spectrum specOut, Tuple3d color)` Computes color of outgoing light ray for given input.

Methods inherited from class de.grogra.imp3d.shading.Material
`renderLine, renderLine`

Methods inherited from class de.grogra.imp3d.shading.ColorMapNode
`drawImage, getIcon, getIconBounds, getIconSource, getImage, getImage, getImageSource, getInputData, getPreferredIconSize, getRenderedImage, getSizeRatio, isMutable, paintIcon, prepareIcon, renderImage`

Methods inherited from class de.grogra.imp3d.shading.ChannelMapNode
`accept, getFloatValue, getInput, getObjectValue, setInput`

Methods inherited from class de.grogra.graph.impl.Node
`addEdgeBitsTo, addReference, appendBranchNode, appendBranchNode, appendReferencesTo, clone, clone, cloneGraph, dump, dumpTree, dup, dupUnmanagedFields, edgeChanged, fieldModified, findAdjacent, get, getAccessor, getAccessor, getAttributes, getAxisParent, getBoolean, getBranch, getBranchLength, getBranchNode, getBranchTail, getByte, getChar, getCommonAncestor, getCurrentGraphState, getDirectChildCount, getDouble, getEdgeAttributeAccessor, getEdgeAttributes, getEdgeBitsTo, getEdgeTo, getExtentIndex, getFirst, getFirstEdge, getFloat, getGraph, getId, getIndex, getInstantiator, getInt, getLayer, getLong, getManageableType, getName, getNeighbor, getNext, getNType, getObject, getOrCreateEdgeTo, getOrNull, getPersistenceManager, getPredecessor, getProvider, getShort, getSource, getStamp, getSuccessor, getSymbol, getSymbolColor, getTarget, getTransaction, getUserField, getUserFieldCount, getXClass, getXData, hasName, initProvider, initXClass, insertBranchNode, insertBranchNode, instantiateGraph, isAncestorOf, isDirection, isManagingInstance, isMarked, isRoot, isSource, isTarget, manageableReadResolve, manageableWriteReplace, paramString, removeAll, removeEdgeBitsTo, removeFromChain, removeFromChain, removeReference, setBranch, setBranch, setExtentIndex, setGraphForDeserialization, setLayer, setMark, setName, setSuccessor, setSuccessor, specialEdgeAdded, specialEdgeRefModified, specialEdgeRemoved, toString, writeReplace`

Methods inherited from class de.grogra.graph.impl.Edge
`addEdgeBits, getBitMark, getEdgeBits, getObjectMark, getSpecialEdgeDescriptor, parseEdgeKeys, remove, removeEdgeBits, setBitMark, setEdgeBits, setObjectMark, testEdgeBits`

Methods inherited from class java.lang.Object
`equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Methods inherited from interface de.grogra.math.ChannelMap
`accept, getFloatValue, getObjectValue, getStamp`

Methods inherited from interface de.grogra.pf.ui.RenderedIcon
`getStamp`

Methods inherited from interface de.grogra.persistence.PersistenceCapable
`getBitMark, getObjectMark, setBitMark, setObjectMark`

Field Detail

### $TYPE

    public static final Node.NType $TYPE

### disableLight$FIELD

    public static final Node.NType.Field disableLight$FIELD

### disableSun$FIELD

    public static final Node.NType.Field disableSun$FIELD

### radianceFactor$FIELD

    public static final Node.NType.Field radianceFactor$FIELD

### sun$FIELD

    public static final Node.NType.Field sun$FIELD

### turbidity$FIELD

    public static final Node.NType.Field turbidity$FIELD

Constructor Detail

### SunSkyLight

    public SunSkyLight()

Method Detail

### accept

    public void accept(ChannelMapNodeVisitor visitor)

  Overrides:
    `accept` in class `ChannelMapNode`

### accept

    public void accept(LightVisitor visitor)

### accept

    public void accept(ShaderVisitor visitor)

### completeRay

    public double completeRay(Environment env,
                              Point3d vertex,
                              Ray out)

  Specified by:
    `completeRay` in interface `Emitter`

### computeBSDF

    public float computeBSDF(Environment env,
                             Vector3f in,
                             Spectrum specIn,
                             Vector3f out,
                             boolean adjoint,
                             Spectrum bsdf)

  Description copied from interface: `Scattering`
  Evaluates bidirectional scattering distribution function for given input.

  The computed spectrum is an integral over the spectrum of the following product:

  |cos θ| BSDF(ωi, νi; ωo, νo)
  where BSDF is the bidirectional scattering distribution function (= BRDF + BTDF) at the point `env.point`, ωi the (negated) direction of the incoming light ray, νi the frequency where the incoming ray is sampled, ωo the direction of the outgoing light ray, νo the frequency where the outgoing ray is sampled, and θ the angle between the surface normal and `out`.

  If `adjoint` is `false`, `in` and `out` describe true light rays from light sources to sensors. In this case, ωi = `in`, ωo = `out`, and the integral is

  `bsdf`(ν) = |cos θ| ∫ BSDF(`in`, νi; `out`, ν) `specIn`(νi) dνi
  Otherwise, `adjoint` is `true`. `in` and `out` then describe importance rays (inverse light rays from sensors to light sources). In this case, ωi = `out`, ωo = `in`, and the integral is
  `bsdf`(ν) = |cos θ| ∫ BSDF(`out`, ν; `in`, νo) `specIn`(νo) dνo

  If this `Scattering` instance is in fact a `Light` source, `adjoint` is `false`, and the BSDF is defined as BSDF(`in`, μ; ω, ν) = L1(ω, ν) δ(μ - ν), i.e., the directional distribution of the emitted radiance at `env.point`, see `Emitter`. In this case, `in` is not used.

  If this `Scattering` instance is in fact a `Sensor`, `adjoint` is `true`, and the BSDF is defined as BSDF(ω, ν; `in`, μ) = W1(ω, ν) δ(μ - ν), i.e., the directional distribution of the emitted importance at `env.point`, see `Emitter`. In this case, `in` is not used.

  The computation should be physically valid. This excludes, e.g., ambient or emissive light contributions.

  The returned value is the value of the probability density pω that would be calculated by `Scattering.generateRandomRays(de.grogra.ray.physics.Environment, javax.vecmath.Vector3f, de.grogra.ray.physics.Spectrum, de.grogra.ray.util.RayList, boolean, java.util.Random)` if the ray happened to be one of the randomly generated rays.

  Specified by:
    `computeBSDF` in interface `Scattering`
  Parameters:
    `env` - the environment for scattering
    `in` - the (negated) direction unit vector of the incoming ray (i.e., pointing away from the surface)
    `specIn` - the spectrum of the incoming ray
    `out` - the direction unit vector of the outgoing ray (i.e., pointing away from the surface)
    `adjoint` - light ray or importance ray?
    `bsdf` - the computed spectrum of the outgoing ray will be placed in here
  Returns:
    the value of the probability density for the ray direction

### computeExitance

    public double computeExitance(Environment env,
                                  Spectrum exitance)

  Description copied from interface: `Emitter`
  Evaluates the exitance function for given input. The computed value is the spectrum of the radiant exitance (emitted power per area) L0j(x, ν) at the point `env.point` in case of light sources, or the corresponding function W0j(x, ν) in case of sensors.

  The returned value is the value of the probability density px that would be calculated by `Emitter.generateRandomOrigins(de.grogra.ray.physics.Environment, de.grogra.ray.util.RayList, java.util.Random)` if `env.point` happened to be one of the randomly generated origins.

  Specified by:
    `computeExitance` in interface `Emitter`
  Parameters:
    `env` - the environment for scattering
    `exitance` - the exitance values will be placed in here
  Returns:
    the value of the probability density for the ray origin

### computeMaxRays

    public void computeMaxRays(Environment env,
                               Vector3f in,
                               Spectrum specIn,
                               Ray reflected,
                               Tuple3f refVariance,
                               Ray transmitted,
                               Tuple3f transVariance)

  Description copied from interface: `Shader`
  Computes, for the given input, the reflected and transmitted importance rays for which the reflection/transmission probability densities (integrated over the spectrum) attain a maximum. The reflection probability density (measured with respect to solid angle) for the outgoing importance direction (i.e., incoming light direction) ω, given a fixed incident direction `in`, is
  pr(ω) = cos θ BRDF(ω, `in`) / R
  where BRDF is the bidirectional reflectivity distribution function, θ the angle between the surface normal and ω, and R the total reflectivity for the incident direction, i.e., the integral over cos θ BRDF(ω, `in`). The transmission probability density is defined correspondingly.

  The `color`-fields are set to the total reflectivity/transparency for the incident direction for each color component R, G, B. Thus, for physically plausible BRDF/BTDF, the component-wise sum of `reflected.color` and `transmitted.color` lies in the interval [0, 1], and the difference to 1 is the amount absorbed.

  The `color` may be zero if there is no reflected or transmitted ray, respectively, i.e., if the surface is fully transparent, opaque, or absorbing. The origin-fields of the rays will never be set.

  The computed variances are defined to be, for each color component, (approximations for) the angular mean quadratic deviations of the densities from the returned maximal ray directions. E.g., for perfect reflection/transmission, these variances are zero, whereas for a perfect lambertian reflector, the variance of reflection is ∫ cos θ (1 / π) θ2 dω = (π2 - 4) / 8. This is the value of `Shader.LAMBERTIAN_VARIANCE`.

  The ray properties which are not mentioned are neither used nor modified. These are the origin and its density, and the direction density.

  Specified by:
    `computeMaxRays` in interface `Shader`
  Parameters:
    `env` - the environment for scattering
    `in` - the (negated) direction unit vector of the incoming ray (i.e., pointing away from the surface)
    `specIn` - spectrum of incoming ray
    `reflected` - the reflected ray with maximal probability
    `refVariance` - the angular mean quadratic deviation from `reflected`
    `transmitted` - the transmitted ray with maximal probability
    `transVariance` - the angular mean quadratic deviation from `transmitted`

### generateRandomOrigins

    public void generateRandomOrigins(Environment env,
                                      RayList out,
                                      java.util.Random random)

  Description copied from interface: `Emitter`
  Pseudorandomly generates, for the given input, a set of origins for this emitter. They are generated such that they can be used for Monte Carlo-based photon tracing algorithms in the following way.

  At first, we consider the case where the emitter is in fact a light source. Let L(x, ω, ν) be the emitted spectral radiance for the frequency ν at the light's surface point x in direction ω. The radiant exitance (emitted spectral power per area) at x is defined as

  L0(x, ν) = ∫ cos θ L(x, ω, ν) dω
  where θ is the angle between the surface normal and ω. Now the directional distribution of the emitted radiance at x can be described by the density
  L1(x, ω, ν) = L(x, ω, ν) / L0(x, ν)
  so that the radiance is split into
  L(x, ω, ν) = L0(x, ν) L1(x, ω, ν)
  Let oi and si denote the origins and spectra of the N generated rays (N = `rays.size`). Then for a function f(x, ν) which is to be integrated over the light surface, the sum
  1 / N ∑i si(ν) f(oi, ν)
  is an unbiased estimate for the integral
  ∫ L0(x, ν) f(x, ν) dA
  The integral ranges over the whole surface A of the light source. As a consequence, the spectrum of a ray is to be considered as the ray's radiant spectral power.

  Now if the emitter is a sensor, let W(x, ω, ν) be the emitted spectral importance for frequency ν at the sensors's surface point x in direction ω. The quantities W0(x, ν) and W1(x, ω, ν) are defined similarly to the case of light sources:

  W0(x, ν) = ∫ cos θ W(x, ω, ν) dω
  W(x, ω, ν) = W0(x) W1(x, ω, ν)
  The formulas for light sources are valid for sensors if the L-quantites are replaced by the corresponding W-quantities.

  Let px be the probability density used for the ray origin, then the field `originDensity` is set to px(oi) for each ray. For emitters which are concentrated at a single point (e.g., point lights) px is not a regular function, the value `originDensity` will be set to a multiple of `Scattering.DELTA_FACTOR`.

  The ray properties which are not mentioned in the given formulas are neither used nor modified. These are the direction and its density.

  Specified by:
    `generateRandomOrigins` in interface `Emitter`
  Parameters:
    `env` - the environment
    `out` - the outgoing rays to be generated
    `random` - pseudorandom generator

### generateRandomRays

    public void generateRandomRays(Environment env,
                                   Vector3f out,
                                   Spectrum specOut,
                                   RayList rays,
                                   boolean adjoint,
                                   java.util.Random random)

  Description copied from interface: `Scattering`
  Pseudorandomly generates, for the given input, a set of scattered rays. The scattered rays are generated such that they can be used for a Monte Carlo integration of a function f(ω;ν) over cos θ BSDF(ωi, νi; ωo, νo) in the following way:
  - If `adjoint` is `false`, `out` = ωo describes the direction of an outgoing light ray. In this case, the integration is with respect to ωi. Let g(ω, ν; `out`, μ) = BSDF(ω, ν; `out`, μ)
  - Otherwise, `adjoint` is `true`. In this case, `out` = ωi describes the direction of an outgoing importance ray (an inverse light ray). Now the integration is with respect to ωo. Let g(ω, ν; `out`, μ) = BSDF(`out`, μ; ω, ν)
  Let di and si denote the directions and spectra of the N generated rays (N = `rays.size`). Then, for every frequency ν the sum
  1 / N ∑i si(ν) f(di; ν)
  is an unbiased estimate for the integral
  ∫ cos θ f(ω; ν) g(ω, ν; `out`, μ) `specOut`(μ) dμ dω
  θ is the angle between the surface normal and ω. The domain of integration is the whole sphere, since the bidirectional scattering distribution includes both reflection and transmission (BSDF = BRDF + BTDF).

  If this `Scattering` instance is in fact a `Light` source, `adjoint` is `true`, and the BSDF is defined as BSDF(`out`, μ; ω, ν) = L1(ω, ν) δ(μ - ν), i.e., the directional distribution of the emitted radiance at `env.point`, see `Emitter`. In this case, `out` is not used.

  If this `Scattering` instance is in fact a `Sensor`, `adjoint` is `false`, and the BSDF is defined as BSDF(ω, ν; `out`, μ) = W1(ω, ν) δ(μ - ν), i.e., the directional distribution of the emitted importance at `env.point`, see `Emitter`. In this case, `out` is not used.

  Let pω be the probability density used for the ray direction (measured with respect to solid angle ω), then the field `directionDensity` of the ray i is set to pω(di). For ideal specular reflection or transmission, or for directional lights or sensors, pω is not a regular function, the value `directionDensity` will be set to a multiple of `Scattering.DELTA_FACTOR`.

  The ray properties which are not mentioned in the given formulas are neither used nor modified. These are the origin and its density.

  Specified by:
    `generateRandomRays` in interface `Scattering`
  Parameters:
    `env` - the environment for scattering
    `out` - the direction unit vector of the outgoing ray (i.e., pointing away from the surface)
    `specOut` - the spectrum of the outgoing ray
    `rays` - the rays to be generated
    `adjoint` - represents `out` a light ray or an importance ray?
    `random` - pseudorandom generator
  See Also:
    `Scattering.computeBSDF(de.grogra.ray.physics.Environment, javax.vecmath.Vector3f, de.grogra.ray.physics.Spectrum, javax.vecmath.Vector3f, boolean, de.grogra.ray.physics.Spectrum)`

### getAverageColor

    public int getAverageColor()

  Description copied from interface: `Scattering`
  Returns an average color for the scattering entity. This color is used for simplified graphical representations of the corresponding objects.

  Specified by:
    `getAverageColor` in interface `ColorMap`
  Specified by:
    `getAverageColor` in interface `Scattering`
  Returns:
    an average color in Java's default sRGB color space, encoded as an int (0xAARRGGBB).

### getFlags

    public int getFlags()

  Specified by:
    `getFlags` in interface `Scattering`

### getLightType

    public int getLightType()

  Description copied from interface: `Light`
  Determines the type of light source which is represented by this light.

  Specified by:
    `getLightType` in interface `Light`
  Returns:
    one of `Light.NO_LIGHT`, `Light.POINT`, `Light.AREA`, `Light.DIRECTIONAL`, `Light.SKY`, `Light.AMBIENT`.

### getNTypeImpl

    protected Node.NType getNTypeImpl()

  Description copied from class: `Node`
  This method returns the `Node.NType` which describes the managed fields of the class of this node. This method has to be implemented in every concrete subclass.

  Overrides:
    `getNTypeImpl` in class `Node`
  Returns:
    type describing the managed fields of the class of this node

### getRadianceFactor

    public float getRadianceFactor()

### getSun

    public Vector3d getSun()

### getTotalPower

    public double getTotalPower(Environment env)

  Description copied from interface: `Light`
  Computes the total power of this light source which is emitted to the region defined by `env.bounds`. Note that the computed value is not necessarily exact: It should be used just as a hint, e.g., when one of a set of lights has to be chosen randomly on the basis of their relative power.

  Specified by:
    `getTotalPower` in interface `Light`
  Parameters:
    `env` - environment which defines the bounds of the scene
  Returns:
    total power emitted to the region `env.bounds`

### getTurbidity

    public float getTurbidity()

### isDisableLight

    public boolean isDisableLight()

### isDisableSun

    public boolean isDisableSun()

### isIgnoredWhenHit

    public boolean isIgnoredWhenHit()

  Description copied from interface: `Light`
  Determines whether the light source shall be ignored when a shot ray happens to hit the geometry of the light source.

  Specified by:
    `isIgnoredWhenHit` in interface `Light`
  Returns:
    `true` iff the light source shall be ignored

### isShadowless

    public boolean isShadowless()

  Description copied from interface: `Light`
  Determines whether the light source casts shadows or not.

  Specified by:
    `isShadowless` in interface `Light`
  Returns:
    `true` iff the light source does not cast shadows

### isTransparent

    public boolean isTransparent()

  Specified by:
    `isTransparent` in interface `Shader`

### newInstance

    protected Node newInstance()

  Description copied from class: `Node`
  This method returns a new instance of the class of this node. This method has to be implemented in every concrete subclass.

  Overrides:
    `newInstance` in class `Node`
  Returns:
    new instance of class of this node

### setDisableLight

    public void setDisableLight(boolean value)

### setDisableSun

    public void setDisableSun(boolean value)

### setRadianceFactor

    public void setRadianceFactor(float value)

### setSun

    public void setSun(Vector3d value)

### setTurbidity

    public void setTurbidity(float value)

### shade

    public void shade(Environment env,
                      RayList in,
                      Vector3f out,
                      Spectrum specOut,
                      Tuple3d color)

  Description copied from interface: `Shader`
  Computes color of outgoing light ray for given input. The computed value is, for each color component j = R, G, B, the following sum over all incident rays k:
  ∑k |cos θk| BSDFj(ωk, `out`) ck,j
  where BSDFj is the bidirectional scattering distribution function (= BRDF + BTDF) at the point `env.point`, ωk and ck the direction and color of ray k, and θk the angle between the surface normal and ωk.

  The computation may include physically invalid contributions, which may not fit into the formula above, e.g., ambient or emissive light contributions.

  Specified by:
    `shade` in interface `Shader`
  Parameters:
    `env` - the environment for scattering
    `in` - the incoming rays
    `out` - the direction unit vector of the outgoing ray (i.e., pointing away from the surface)
    `specOut` - spectrum of outgoing ray
    `color` - the output color will be placed in here

Overview | Package | Class | Tree | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD